/* Copyright 2009 ObjectFactory (http://www.wingnest.com/softs/grails-plugins)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/
import org.codehaus.groovy.grails.plugins.appBean.*
import org.apache.log4j.Logger

/**
 * @author Shigeru GOUGI
 *
 */
class AppBeanGrailsPlugin {
    static log = Logger.getLogger("grails.app.plugins.AppBean")
	def artefacts = [ org.codehaus.groovy.grails.plugins.appBean.AppBeanClassArtefactHandler ]
	def version = "0.1"
	def author = "Shigeru GOUGI"
    def watchedResources = [ "file:./grails-app/beans/**/*.groovy",
                             "file:./plugins/*/grails-app/beans/**/*.groovy" ]
	def doWithSpring = {
		application.appBeanClasses.each { beanClass ->
			def scope = beanClass.scope
			def beanName = beanClass.propertyName			
			"${beanName}"(beanClass.getClazz()) { bean ->
				bean.autowire =  true
				bean.scope = scope
			}
            log.info("doWithSpring; ${beanName}, scope = ${scope}")
		}
	}
	def onChange = { event ->	
		if(event.source) {
			def beanClass = application.addArtefact(AppBeanClassArtefactHandler.TYPE, event.source)
			if(beanClass) {
				def beanName = beanClass.propertyName
	            def scope = beanClass.scope	            
				def beans = beans {
					"$beanName"(beanClass.getClazz()) { bean ->
						bean.autowire =  true
                        if(scope) {
                            bean.scope = scope
                        }
					}					
				}
	            beans.registerBeans(event.ctx)
	            log.info("onChange; ${beanName}, scope= ${scope}")
			}
		 }
	} 

}